//----------------------------------------------------------------------//
// NyanFi																//
//  eLXgrA[													//
//----------------------------------------------------------------------//
#ifndef TxtViewerH
#define TxtViewerH

//---------------------------------------------------------------------------
#include "usr_mmfile.h"
#include "Global.h"

//---------------------------------------------------------------------------
//P}b`pK\
#define WORD_MATCH_PTN	"\\w+|[-]+|[-]+|[@-[]+|[-`-yO-X]+|[-]+|#[0-9a-fA-F]{3,6}"

//N挟̐K\
#define LINK_MATCH_PTN	"(https?://[\\w/:%#$&?()~.=+-]+)|(file:///[^/*?\"<>|j]+)|(mailto:[a-zA-Z0-9]+[\\w.-]*@[\\w.-]+)"
	
#define MAX_BIN_HCH_X	67
#define MARK_WIDTH		8

#define MAX_EM_PTN		7	//\p^[

//---------------------------------------------------------------------------
//\se
struct line_rec {
	int  LineNo;			//sԍ
	int  LineIdx;			//ssCfbNX
	bool hasCR;				//sɉsR[h
	WideChar topQch;
	int  RemPos0;			//RgJnʒu
	int  RemPos1;			//RgIʒu
};

//---------------------------------------------------------------------------
class TTxtViewer
{
private:
	TPaintBox	*ViewBox;		//rA[`pPaintBox
	TCanvas		*ViewCanvas;
	TScrollBar	*ScrBar;
	UsrScrollPanel *ScrPanel;
	TPaintBox	*RulerBox;		//[
	TStatusBar	*SttHeader;		//Xe[^Xwb_
	TPanel		*ColorPanel;	//J[\ʒul̃J[\
	TPaintBox	*MarginBox;		//E]

	bool isExtWnd;				//OEBhEŕ\

	UnicodeString EmPtn[MAX_EM_PTN];	//\p^[
	TColor EmFgC[MAX_EM_PTN];			//F
	TColor EmBgC[MAX_EM_PTN];			//wiF

	Graphics::TBitmap *ImgBuff;

	TPoint LastPos;
	int	 LastTop;
	bool LastSel;
	bool SelSkip;
	bool inh_Repaint;

	UnicodeString useFontName;		//gptHg
	int  useFontSize;				//gptHgTCY(Zbgl)

	int  FontHeight;				//tHg
	int  LineHeight;				//s
	int  HchWidth;					//p(px)
	int  TabWidth;					//^u(px)
	int  CurHchX;					//㉺ړXʒu(pP)
	int  MaxHchX;					//Xʒu̍ől(pP)
	bool IsIrregFont;				//擾ƕ\sv(Ricty Diminished ΍)
	int  LeftMargin;
	int  CurTop;					//\擪s(1x[X)
	int  CurBottom;					//\ŉs
	int  TopXpos;					//s̕\Jnʒu
	int  TopMargin;					//s̗]

	DynamicArray<int>  FixWdList;	//Œ蒷Xg
	DynamicArray<bool> IsNumList;	//ڂl

	TStringList *RemLnList;			//PsRgʕ
	TStringList *RemBgnList;		//ubNRgJn
	TStringList *RemEndList;		//ubNRgI

	UnicodeString QuotStr;			//̈p
	bool useEsc;					//ŃGXP[vV[PX

	UnicodeString ReservedPtn;		//\
	bool ReservedCase;				//\ő召

	UnicodeString SymbolChs;		//V{
	UnicodeString NumericPtn;		//l
	UnicodeString CharPtn;			//

	UnicodeString UsrKeyword;		//[U`L[[h
	bool   UsrKeywdCase;			//[U`L[[hő召
	TColor UsrKeywdCol;				//[U`L[[h̕F

	UnicodeString UsrKeyword2;		//[U`L[[h
	bool   UsrKeywdCase2;			//[U`L[[hő召
	TColor UsrKeywdCol2;			//[U`L[[h̕F

	TBytes FindByte0, FindByte1;	//oCi
	TBytes FindMask;				//oCip}XN

	bool alt_BackSlash;				//\  _(U+2216)ŕ\

	line_rec BinLineRec;
	line_rec* __fastcall AddDispLine(UnicodeString s, int lno, int lidx = 0);
	void __fastcall ClearDispLine();

	void __fastcall AlphaBlendCsvCol(TCanvas *cv, int max_x, int y, int h);
	void __fastcall onRulerPaint(TObject *Sender);
	void __fastcall PaintText();
	bool __fastcall SetToggleSw(bool &sw, UnicodeString prm);

	void __fastcall SetScrBar();

	UnicodeString __fastcall ArrayToTsv(TStringDynArray lst);
	void __fastcall FormatFixed(TStringList *txt_lst);

	TPoint __fastcall nrm_Pos(TPoint p);
	bool __fastcall has_CR(UnicodeString s);
	int  __fastcall add_CharWidth(WideChar c, int w);
	int  __fastcall get_StrWidth(UnicodeString s);
	int  __fastcall get_CurEndPos();
	void __fastcall adjust_PosX();
	void __fastcall to_Lead_if_Trail(bool sel = false);
	void __fastcall set_SelEnd();
	void __fastcall set_CurCsvCol();

	WideChar __fastcall get_CurChar();
	int  __fastcall cv_PosX_to_HchX(int px);
	void __fastcall TabTextOut(UnicodeString s, TCanvas *cv, int &x, int max_x);
	void __fastcall IniSelected(bool sel = false);
	void __fastcall SetPosFromPt(int x, int y);
	bool __fastcall PtInSelected(int x, int y);
	void __fastcall UpdatePos(bool up_pos = false, bool force = false);
	void __fastcall UpdateVisible();
	int  __fastcall get_MovePrm(UnicodeString prm);
	int  __fastcall to_Bytes(UnicodeString s, bool &case_sw, int code_page = 932);

	int  __fastcall GetComCmdIndex(UnicodeString cmd);

public:
	TForm *OwnerForm;

	MemMapFile	 *MMF;				//}bvht@C

	TStringList  *TxtBufList;		//eXg
	TStringList  *TxtBufList2;		//HTMLTEXTϊ̓eXg
	TStringList  *DispLines;		//\sXg(eLXgp)

	UnicodeString FileName;			//t@C
	UnicodeString OrgName;			//ꎞ𓀂Ăꍇ̌t@C
	file_rec     *FileRec;
	bool 		  HasBOM;			//BOMt
	UnicodeString LineBreakStr;		//sR[h
	UnicodeString SttHdrInf;		//t@C
	UnicodeString MarkListStr;		//}[NXg

	bool isReady;
	bool isFitWin;					//܂ԂEBhE
	bool isText;					//eLXg\
	bool isBinary;					//oCi\
	bool isXDoc2Txt;				//xdoc2txtgp
	bool isHtm2Txt;					//HTMLTEXTϊ[h
	bool isFixedLen;				//Œ蒷\[h
	bool isCSV;						//CSV(TSV܂)
	bool isTSV;
	bool isSelected;				//t@CI
	bool ShowRuby;					//r\
	bool isAozora;					//󕶌Ɍ`
	bool isLog;						//^XNO
	bool isClip;					//Nbv{[h
	bool isIniFmt;					//INIt@CȂ
	bool isAwstats;					//AwstatsO
	bool isNyanTxt;					//NyanFipeLXg
	bool isLimited;					//TCYL
	bool isContinue;				//Ōォ瑱
	bool isSelMode;					//I[h
	bool isBoxMode;					//`I[h
	bool ExtClicked;				//eLXgONbNꂽ
	bool Selecting;					//}EXőI
	bool PtInSelect;				//I͈͓NbN
	bool reqCurPos;					//ƂɃt@C[̃J[\ʒuݒ

	int  TabLength;					//^u
	int  LineCount;					//1y[W̍s(-1)
	int  MaxLine;					//ős
	int  MaxDispLine;				//ő\s

	bool isTail;					//\
	bool isReverse;					//t
	int  TailLine;					//s
	bool TopIsHeader;				//擪sCSVږ

	unsigned int BinarySize;		//oCiǍTCY
	unsigned __int64 BinFileSize;	//t@CTCY
	__int64 TopAddress;				//擪AhX

	TPoint CurPos;					//J[\ʒu(P 0x[X)
	TPoint SelStart, SelEnd;		//ʏI͈(P)
	TPoint BoxStart, BoxEnd;		//`I͈(pP)
	int  MaxFoldWd;					//ő܂Ԃ
	int  CsvCol;					//CSV(Œ蒷\[h)

	int  SortMode;					//\[g[h(0:Ȃ/ 1:/ -1:~)
	int  SortCol;					//\[g(Œ蒷\[h)

	UnicodeString FindWord;			//
	UnicodeString RegExPtn;			//K\p^[
	UnicodeString LastSelWord;		//O FindSel`ŗp
	bool isCase;					//召
	bool isRegEx;					//K\
	bool isMigemo;					//Migemo[h
	bool isBytes;					//oCg񌟍
	int  BinCodePage;				//R[hy[W
	bool Highlight;					//}b`̋\
	bool LastFound;					//Ǒ
	TPoint FoundPos;				//Õqbgʒu

	UnicodeString IncSeaWord;		//CN^T[`͌
	bool isIncSea;					//CN^T[`
	bool isIncMigemo;				//Migemo[h

	UnicodeString HeadlinePtn;		//o̐K\
	UnicodeString RubyPtn;			//r̐K\

	TStringList *ColBufList;
	TColor color_Cursor;		//CJ[\̐F
	TColor color_selItem;		//Iڂ̔wiF
	TColor color_fgSelItem;		//Iڂ̕F
	TColor color_Folder;		//fBNg̕F
	TColor color_Error;			//G[̕F
	TColor color_bgView;		//eLXgrA[̔wiF
	TColor color_fgView;		//eLXgrA[̕F
	TColor color_Margin;		//eLXgrA[̗]
	TColor color_bgLineNo;		//eLXgrA[̍sԍwiF
	TColor color_LineNo;		//eLXgrA[̍sԍF
	TColor color_Mark;			//eLXgrA[̃}[N
	TColor color_bgRuler;		//[̔wiF
	TColor color_fgRuler;		//[̖ڐF
	TColor color_bdrLine;		//sԍ̋E
	TColor color_bdrFold;		//܂ԂE
	TColor color_bdrFixed;		//Œ蒷\̏cr
	TColor color_Comment;		//Rg̕F
	TColor color_Strings;		//̕F
	TColor color_Reserved;		//\̕F
	TColor color_Symbol;		//V{̕F
	TColor color_Numeric;		//l̕F
	TColor color_fgEmpBin1;		//oCiF1
	TColor color_fgEmpBin2;		//oCiF2
	TColor color_fgEmpBin3;		//oCiF3
	TColor color_Headline;		//o̕F
	TColor color_URL;			//URL̕F
	TColor color_LocalLink;		//[Jt@Cւ̃N
	TColor color_fgEmp;			//F
	TColor color_bgEmp;			//wiF
	TColor color_Ruby;			//r
	TColor color_TAB;			//^u\F
	TColor color_CR;			//s\F
	TColor color_HR;			//r̐F
	TColor color_Ctrl;			//Rg[R[h

	__fastcall TTxtViewer(TForm *frm, TPaintBox *viewbox, TScrollBar *scrbar, UsrScrollPanel *sp,
							TStatusBar *stthdr, TPaintBox *ruler, TPanel *colref, TPaintBox *mgn_box = NULL);
	__fastcall ~TTxtViewer();

	bool __fastcall CloseAuxForm();

	void __fastcall SetColor(TStringList *lst);
	void __fastcall SetColor(UnicodeString prm = EmptyStr);
	void __fastcall SetOptColor();
	void __fastcall SetMetric(bool set_hi = false);

	void __fastcall UpdateScr(int lno = 1);
	void __fastcall AssignText(TStrings *lst = NULL, int lno = 1, int sort_mode = 0);
	bool __fastcall AssignBin(__int64 top_adr = 0, bool reload = false, unsigned int adr = 0);
	void __fastcall Repaint(bool force = false);
	void __fastcall Clear();

	void __fastcall SetSttInf(UnicodeString msg = EmptyStr);
	void __fastcall SttHeaderDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel, TRect Rect);

	void __fastcall onMouseDown(int x, int y);
	void __fastcall onMouseMove(int x, int y);
	void __fastcall onMouseUp();
	void __fastcall onDblClick();
	void __fastcall onRulerDblClick(TObject *Sender);

	void __fastcall CursorLeft(bool sel = false);
	void __fastcall CursorRight(bool sel = false);
	void __fastcall CursorUp(bool sel = false, UnicodeString prm = EmptyStr);
	void __fastcall CursorDown(bool sel = false, UnicodeString prm = EmptyStr);
	void __fastcall MovePage(bool is_down, bool sel = false);
	void __fastcall ScrollAdjust();
	void __fastcall MoveScroll(bool is_down, UnicodeString prm, bool move_csr = false);
	void __fastcall LineTop(bool sel = false);
	void __fastcall MoveLineTop(bool is_next, bool sel = false);
	void __fastcall LineEnd(bool sel = false);
	void __fastcall TextTop(bool sel = false);
	void __fastcall TextEnd(bool sel = false);
	bool __fastcall set_PosFromCol(int col);

	void __fastcall WordLeft(bool sel = false);
	void __fastcall WordRight(bool sel = false);

	void __fastcall ClipCopy(bool append = false);

	line_rec* __fastcall get_LineRec(int idx);
	UnicodeString __fastcall get_DispLine(int idx, int b0 = 0, int b1 = 15);

	UnicodeString __fastcall get_SelText(bool clr_sel = false);
	UnicodeString __fastcall get_CurLine(bool to_cr = false);
	int __fastcall get_CurLineNo();
	__int64 __fastcall get_CurAddrA();
	unsigned int __fastcall get_CurAddrR();
	unsigned int __fastcall get_OfsR(int xp);
	TPoint __fastcall get_CurLinePos();

	void __fastcall SelectAll();
	UnicodeString __fastcall GetCurWord(bool select = false, UnicodeString ptn = EmptyStr, int *xp = NULL);
	void __fastcall SelLine(bool cr = false);

	int  __fastcall change_CodePage(UnicodeString prm);

	UnicodeString __fastcall GetCurImgFile();

	bool __fastcall SearchCore(bool is_down, UnicodeString kwd,
		bool case_sw = false, bool reg_sw = false, bool bytes_sw = false, bool from_pos = false);
	bool __fastcall SearchDown(UnicodeString kwd,
		bool case_sw = false, bool reg_sw = false, bool bytes_sw = false, bool from_pos = false);
	bool __fastcall SearchUp(UnicodeString kwd,
		bool case_sw = false, bool reg_sw = false, bool bytes_sw = false);
	bool __fastcall SearchDownBytes(UnicodeString kwd, bool case_sw, bool reg_sw);
	bool __fastcall SearchUpBytes(UnicodeString kwd, bool case_sw, bool reg_sw);
	bool __fastcall SearchSel(bool up_sw, bool em_sw);
	bool __fastcall SearchPair();

	bool __fastcall ToLine(int lno, int col = -1);
	bool __fastcall ToAddrR(unsigned int adr);
	bool __fastcall ToAddrA(__int64 adr);
	void __fastcall JumpLine(UnicodeString ln_str);

	void __fastcall MarkLine(int lno);
	bool __fastcall IsMarked(int lno = 0);

	void __fastcall add_ViewHistory();

	void __fastcall GetDumpList(TStringList *lst);

	void __fastcall IncSearch(UnicodeString keystr);

	bool __fastcall StdKeyOperation(UnicodeString keystr);
	bool __fastcall ExeCommand(const _TCHAR *cmd, UnicodeString prm = EmptyStr);
	bool __fastcall IsCmdAvailable(UnicodeString cmd);
	bool __fastcall IsCmdInhibited(UnicodeString cmd);
};
//---------------------------------------------------------------------------
extern TTxtViewer *TxtViewer;

//---------------------------------------------------------------------------
#endif
